;;
;; sha1 - Scheme wrapper for Steve Reid's Public Domain sha1 implementation
;;
;; All code in this egg is in the Public Domain

#>#include "sha1-base.c"<#

(module sha1-api

(;export
  name version
  context-size digest-length block-length
  init update final raw-update)

(import scheme
  (chicken base)
  (chicken foreign))

;;

(define name 'sha1)
(define version "1.0.0")

;;

(define-foreign-variable DIGEST_LENGTH size_t "SHA1_DIGEST_LENGTH")
(define-foreign-variable BLOCK_LENGTH size_t "SHA1_BLOCK_LENGTH")
(define-foreign-variable CONTEXT_SIZE size_t "sizeof(SHA1_CTX)")

(define context-size CONTEXT_SIZE)
(define digest-length DIGEST_LENGTH)
(define block-length BLOCK_LENGTH)

;;

(define init (foreign-lambda void SHA1Init nonnull-c-pointer))
(define update (foreign-lambda void SHA1Update nonnull-c-pointer nonnull-scheme-pointer size_t))
(define final (foreign-lambda void SHA1Final nonnull-c-pointer nonnull-scheme-pointer))
(define raw-update (foreign-lambda void SHA1Update nonnull-c-pointer nonnull-c-pointer size_t))

) ;sha1-api
